<?php

Yii::import('application.modules.core_models.models._base.BaseModel');

/**
 * This is the model base class for the table "practice_photo".
 * DO NOT MODIFY THIS FILE! It is automatically generated by giix.
 * If any changes are necessary, you must set or override the required
 * property or method in class "PracticePhoto".
 *
 * Columns in table "practice_photo" available as properties of the model,
 * followed by relations of table "practice_photo" available as properties of the model.
 *
 * @property integer $id
 * @property integer $practice_id
 * @property string $photo_path
 * @property string $photo_name
 * @property string $sort_order
 * @property integer $cover
 * @property integer $width
 * @property integer $height
 * @property string $caption
 *
 * @property Practice $practice
 */
abstract class BasePracticePhoto extends BaseModel
{

    public $uploadPath;

    public function init()
    {
        parent::init();
        if (
                (isset(Yii::app()->controller) && Yii::app()->controller->module->id == 'api') ||
                php_sapi_name() == "cli"
        ) {
            $this->uploadPath = Yii::getPathOfAlias('api') . '/../providers/' . Yii::app()->params['upload_practices'];
        } else {
            $this->uploadPath = $this->basePath . Yii::app()->params['upload_practices'];
        }
    }

    public static function model($className = __CLASS__)
    {
        return parent::model($className);
    }

    public function tableName()
    {
        return 'practice_photo';
    }

    public static function representingColumn()
    {
        return 'photo_path';
    }

    public function rules()
    {
        return array(
            array('practice_id, photo_path, photo_name', 'required'),
            array('practice_id, cover', 'numerical', 'integerOnly' => true),
            array('photo_path', 'length', 'max' => 255),
            array('photo_path', 'ext.CustomValidators.CheckDirectory', 'uploadPath' => $this->uploadPath),
            array('photo_name, caption', 'length', 'max' => 100),
            array('sort_order', 'length', 'max' => 11),
            array('width, height', 'length', 'max' => 5),
            array('sort_order, cover, width, height', 'default', 'setOnEmpty' => true, 'value' => null),
            array('id, practice_id, photo_path, photo_name, sort_order, cover, width, height, caption', 'safe',
                'on' => 'search'),
        );
    }

    public function relations()
    {
        return array(
            'practice' => array(self::BELONGS_TO, 'Practice', 'practice_id'),
        );
    }

    public function pivotModels()
    {
        return array(
        );
    }

    public function attributeLabels()
    {
        return array(
            'id' => Yii::t('app', 'ID'),
            'practice_id' => Yii::t('app', 'Practice'),
            'photo_path' => Yii::t('app', 'Photo Path'),
            'photo_name' => Yii::t('app', 'Photo Name'),
            'sort_order' => Yii::t('app', 'Sort Order'),
            'cover' => Yii::t('app', 'Cover'),
            'width' => Yii::t('app', 'Width'),
            'height' => Yii::t('app', 'Height'),
            'caption' => Yii::t('app', 'Caption'),
        );
    }

    public function search()
    {
        $criteria = new CDbCriteria;

        $criteria->with = array('practice');

        $criteria->compare('id', $this->id);
        if (!intval($this->practice_id) && is_string($this->practice_id) && strlen($this->practice_id) > 0) {
            $criteria->compare('practice.name', $this->practice_id, true);
        } else {
            if (intval($this->practice_id)) {
                $criteria->compare('t.practice_id', $this->practice_id, true);
            }
        }
        $criteria->compare('photo_path', $this->photo_path, true);
        $criteria->compare('photo_name', $this->photo_name, true);
        $criteria->compare('sort_order', $this->sort_order, true);
        $criteria->compare('cover', $this->cover);
        $criteria->compare('width', $this->width);
        $criteria->compare('height', $this->height);
        $criteria->compare('caption', $this->caption, true);

        return new CActiveDataProvider($this, array(
            'criteria' => $criteria,
            'pagination' => array('pageSize' => 100)
        ));
    }

    public static function label($n = 1)
    {
        return Yii::t('app', 'PracticePhoto|PracticePhotos', $n);
    }

}
